function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import { Phases, symbol } from './constants';

const givenEvents = (dependencies, events) => {
  const {
    readModel,
    as,
    init,
    saga,
    getInitPromise,
    properties
  } = dependencies;
  let promiseResolve = null,
      promiseReject = null;
  const promise = new Promise((resolve, reject) => {
    promiseResolve = resolve;
    promiseReject = reject;
  });

  const pool = _objectSpread({}, dependencies, {
    promise
  });

  promise[symbol] = Object.create(null);
  promise[symbol].resolve = promiseResolve;
  promise[symbol].reject = promiseReject;
  promise[symbol].initPromise = getInitPromise(pool);
  promise[symbol].events = events;
  promise[symbol].phase = Phases.GIVEN_EVENTS;
  promise[symbol].properties = {
    RESOLVE_SIDE_EFFECTS_START_TIMESTAMP: 0
  };
  promise.readModel = readModel.bind(null, pool);
  promise.as = as.bind(null, pool);
  promise.saga = saga.bind(null, pool);
  promise.properties = properties.bind(null, pool);
  promise[symbol].initPromise.then(init.bind(null, pool));
  const promiseThen = promise.then.bind(promise);
  const promiseCatch = promise.catch.bind(promise);
  promise.then = promise[symbol].initResolve.bind(null, promiseThen);
  promise.catch = promise[symbol].initResolve.bind(null, promiseCatch);
  return promise;
};

export default givenEvents;
//# sourceMappingURL=given-events.js.map