"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const transformEvents = events => {
  let timestamp = 1;
  const aggregateVersionsMap = new Map();
  const result = [{
    type: 'Init'
  }];

  for (const rawEvent of events) {
    const aggregateVersion = aggregateVersionsMap.has(rawEvent.aggregateId) ? aggregateVersionsMap.get(rawEvent.aggregateId) + 1 : 1;

    const event = _objectSpread({}, rawEvent, {
      aggregateVersion,
      timestamp: timestamp++
    });

    result.push(event);
    aggregateVersionsMap.set(rawEvent.aggregateId, aggregateVersion);
  }

  return result;
};

var _default = transformEvents;
exports.default = _default;
//# sourceMappingURL=transform-events.js.map